
Ruby - Bug #10711

Incorrect error message in coerce failed

01/07/2015 09:22 PM - chrisseaton (Chris Seaton)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.2.0p0 (2014-12-25 revision

49005) [x86_64-darwin14]

Backport: 2.0.0: DONE, 2.1: DONE, 2.2: DONE

Description

$ ruby -v -e '1 & 1.2'

ruby 2.2.0p0 (2014-12-25 revision 49005) [x86_64-darwin14]

-e:1: warning: possibly useless use of & in void context

-e:1:in `&': 1.2 can't be coerced into Float (TypeError)

 from -e:1:in `<main>'

 It's telling me it couldn't coerce a Float into a Float, when it probably means into an Integer (or maybe Fixnum?).

I looked at the C, but couldn't see where the problem is. coerce_failed seems to use the correct value to get the class for the error so

must be something before there.

Associated revisions

Revision 34289fff0fe6fed9bcc23fa27a650a729f54b64b - 01/12/2015 09:56 AM - Eric Wong 

numeric.c: correct error message when coerce fails

numeric.c (bit_coerce): use original value for error message

[ruby-core:67405] [Bug #10711]

test/ruby/test_numeric.rb (test_coerce): check error message

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@49224 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 34289fff - 01/12/2015 09:56 AM - Eric Wong 

numeric.c: correct error message when coerce fails

numeric.c (bit_coerce): use original value for error message

[ruby-core:67405] [Bug #10711]

test/ruby/test_numeric.rb (test_coerce): check error message

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@49224 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 636f19193362cd989758044ab6684adce90cf8b2 - 01/17/2015 04:00 PM - naruse (Yui NARUSE)

merge revision(s) 49224,49234,49235: [Backport #10711]

    * numeric.c (bit_coerce): use original value for error message

      [ruby-core:67405] [Bug #10711]

    * test/ruby/test_numeric.rb (test_coerce): check error message

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@49313 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 636f1919 - 01/17/2015 04:00 PM - naruse (Yui NARUSE)

merge revision(s) 49224,49234,49235: [Backport #10711]

    * numeric.c (bit_coerce): use original value for error message

      [ruby-core:67405] [Bug #10711]

    * test/ruby/test_numeric.rb (test_coerce): check error message

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@49313 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 459c590ca881a80af4583ce4e9fde52c2bf1faf2 - 01/18/2015 08:17 AM - naruse (Yui NARUSE)
merge revision(s) 49225: [Backport #10711]

    * test/ruby/test_numeric.rb (TestNumeric#test_coerce): fixed wrong message.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@49323 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 459c590c - 01/18/2015 08:17 AM - naruse (Yui NARUSE)

merge revision(s) 49225: [Backport #10711]

    * test/ruby/test_numeric.rb (TestNumeric#test_coerce): fixed wrong message.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@49323 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 6b7e6324b460b6f6bea32dc1d15fb3f994569122 - 01/30/2015 06:54 AM - U.Nakamura 

merge revision(s) 49224,49225,49234,49235: [Backport #10711]

    * numeric.c (bit_coerce): use original value for error message

      [ruby-core:67405] [Bug #10711]

    * test/ruby/test_numeric.rb (test_coerce): check error message

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@49443 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 6b7e6324 - 01/30/2015 06:54 AM - U.Nakamura 

merge revision(s) 49224,49225,49234,49235: [Backport #10711]

    * numeric.c (bit_coerce): use original value for error message

      [ruby-core:67405] [Bug #10711]

    * test/ruby/test_numeric.rb (test_coerce): check error message

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@49443 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ee1519777bbd4f57463e23b267653f8f37d7afaa - 06/30/2015 02:58 AM - U.Nakamura 

merge revision(s) 49224,49225,49234,49235: [Backport #10711]

    * numeric.c (bit_coerce): use original value for error message

      [ruby-core:67405] [Bug #10711]

    * test/ruby/test_numeric.rb (test_coerce): check error message

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@51067 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ee151977 - 06/30/2015 02:58 AM - U.Nakamura 

merge revision(s) 49224,49225,49234,49235: [Backport #10711]

    * numeric.c (bit_coerce): use original value for error message

      [ruby-core:67405] [Bug #10711]

    * test/ruby/test_numeric.rb (test_coerce): check error message

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@51067 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 759d12889d3f8b15c414a3a2b9f914729b9afe0e - 07/03/2015 10:15 AM - U.Nakamura 

merge revision(s) 49235: [Backport #10711]

    numeric.c: fix message

    * numeric.c (coerce_failed): fix the error message on non-flonum

 platforms.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@51124 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 759d1288 - 07/03/2015 10:15 AM - U.Nakamura 

merge revision(s) 49235: [Backport #10711]

    numeric.c: fix message
    * numeric.c (coerce_failed): fix the error message on non-flonum

 platforms.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@51124 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 01/07/2015 09:48 PM - normalperson (Eric Wong)

do_coerce modifies x, so stashing the original before seems to fix

the problem.  Maybe I missed something else.  Lightly-tested patch:

--- a/numeric.c

+++ b/numeric.c

@@ -3426,10 +3426,11 @@ static int

bit_coerce(VALUE *x, VALUE *y)

{

if (!FIXNUM_P(*y) && !RB_TYPE_P(*y, T_BIGNUM)) {

VALUE orig = *x;

do_coerce(x, y, TRUE);

if (!FIXNUM_P(*x) && !RB_TYPE_P(*x, T_BIGNUM)

&& !FIXNUM_P(*y) && !RB_TYPE_P(*y, T_BIGNUM)) {

 coerce_failed(*x, *y);

 coerce_failed(orig, *y);

}

}

return TRUE;

#2 - 01/12/2015 11:02 AM - Anonymous

- Status changed from Open to Closed

- % Done changed from 0 to 100

Applied in changeset r49224.

numeric.c: correct error message when coerce fails

numeric.c (bit_coerce): use original value for error message

[ruby-core:67405] [Bug #10711]

test/ruby/test_numeric.rb (test_coerce): check error message

#3 - 01/14/2015 08:02 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2: UNKNOWN to 2.0.0: REQUIRED, 2.1: REQUIRED, 2.2: REQUIRED

memo: see also [ruby-core:67555], [ruby-core:67557], r49234 and r49235.

#4 - 01/17/2015 04:00 PM - naruse (Yui NARUSE)

- Backport changed from 2.0.0: REQUIRED, 2.1: REQUIRED, 2.2: REQUIRED to 2.0.0: REQUIRED, 2.1: REQUIRED, 2.2: DONE

ruby_2_2 r49313 merged revision(s) 49224,49234,49235.

#5 - 01/30/2015 06:54 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.0.0: REQUIRED, 2.1: REQUIRED, 2.2: DONE to 2.0.0: DONE, 2.1: REQUIRED, 2.2: DONE

ruby_2_0_0 r49443 merged revision(s) 49224,49225,49234,49235.

#6 - 06/30/2015 02:59 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.0.0: DONE, 2.1: REQUIRED, 2.2: DONE to 2.0.0: DONE, 2.1: DONE, 2.2: DONE

ruby_2_1 r51067 merged revision(s) 49224,49225,49234,49235.
